;;
;;**********************************************************************
;; $Id: windows.inc 4 2015-01-06 09:02:02Z mkwayisi $
;; ---------------------------------------------------------------------
;; Authored by Michael Kwayisi. Copyright (c) 2014. See license below.
;; Comments are appreciated - mic at kwayisi dot org | www.kwayisi.org
;; ---------------------------------------------------------------------
;; Redistribution and use in source and binary forms, with or without
;; modification, are permitted provided that the following conditions
;; are stringently met:
;;  1. Redistributions of source code must retain the above copyright
;;     notice, this list of conditions, and the following disclaimer.
;;  2. Redistributions in binary form must reproduce the above
;;     copyright notice, this list of conditions, and the following
;;     disclaimer in the documentation and/or other materials provided
;;     with the distribution.
;;  3. The end-user documentation included with the redistribution,
;;     if any, must include the following acknowledgment:
;;       "This product includes software written by Michael Kwayisi."
;;     Alternately, this acknowledgment may appear in the software
;;     itself, if and wherever such 3rd-party acknowledgments appear.
;;  4. Neither the name of the software nor the name of its author
;;     and/or contributors may be used to endorse or promote products
;;     derived from this software without specific prior permission.
;;**********************************************************************
;;

display 'generating code for '

; Determine the target platform.
match =true, win64 {
	display '64-bit platform '
	match =true, unicode \{
		include 'win64wxp.inc'
		rept 0 \{
	\} match , \{
		include 'win64axp.inc'
	\}
	rept 0 {
} match , {
	display '32-bit platform '
	match =true, unicode \{
		include 'win32wxp.inc'
		rept 0 \{
	\} match , \{
		include 'win32axp.inc'
	\}
}

; Additional functions supplied by WinFASM.
macro import lib, [functions] {
	common macro import_#lib \{
		import lib, functions
	\}
}

include 'api/msvcrt40.inc'
purge import

; Define the TCHAR functions for transparent calls.
; Mostly C standard library functions in msvcrt.dll.
match =true, unicode {
	display '(unicode)'
	define	dz du
	define	_fgettc			fgetwc
	define	_fgettchar		_fgetwchar
	define	_fgetts			fgetws
	define	_fputtc			fputwc
	define	_fputtchar		_fputwchar
	define	_fputts			fputws
	define	_ftprintf		fwprintf
	define	_ftscanf		fwscanf
	define	_gettc			getwc
	define	_getts			_getws
	define	_i64tot			_i64tow
	define	_istalnum		iswalnum
	define	_istalpha		iswalpha
	define	_istascii		iswascii
	define	_istcntrl		iswcntrl
	define	_istdigit		iswdigit
	define	_istgraph		iswgraph
	define	_istlower		iswlower
	define	_istprint		iswprint
	define	_istpunct		iswpunct
	define	_istspace		iswspace
	define	_istupper		iswupper
	define	_istxdigit		iswxdigit
	define	_itot			_itow
	define	_ltot			_ltow
	define	_puttc			putwc
	define	_puttchar		putwchar
	define	_putts			_putws
	define	_sntprintf		_snwprintf
	define	_stprintf		swprintf
	define	_stscanf		swscanf
	define	_taccess		_waccess
	define	_tasctime		_wasctime
	define	_tchdir			_wchdir
	define	_tchmod			_wchmod
	define	_tclosedir		_wclosedir
	define	_tcreat			_wcreat
	define	_tcscat			wcscat
	define	_tcschr			wcschr
	define	_tcscmp			wcscmp
	define	_tcscoll		wcscoll
	define	_tcscpy			wcscpy
	define	_tcscspn		wcscspn
	define	_tcsdec			_wcsdec
	define	_tcsdup			_wcsdup
	define	_tcsftime		wcsftime
	define	_tcsicmp		_wcsicmp
	define	_tcsicoll		_wcsicoll
	define	_tcsinc			_wcsinc
	define	_tcslen			wcslen
	define	_tcslwr			_wcslwr
	define	_tcsnbcnt		_wcsncnt
	define	_tcsncat		wcsncat
	define	_tcsnccnt		_wcsncnt
	define	_tcsnccoll		_wcsncoll
	define	_tcsncicoll		_wcsnicoll
	define	_tcsncmp		wcsncmp
	define	_tcsncoll		_wcsncoll
	define	_tcsncpy		wcsncpy
	define	_tcsnextc		_wcsnextc
	define	_tcsnicmp		_wcsnicmp
	define	_tcsnicoll		_wcsnicoll
	define	_tcsninc		_wcsninc
	define	_tcsnset		_wcsnset
	define	_tcspbrk		wcspbrk
	define	_tcsrchr		wcsrchr
	define	_tcsrev			_wcsrev
	define	_tcsset			_wcsset
	define	_tcsspn			wcsspn
	define	_tcsspnp		_wcsspnp
	define	_tcsstr			wcsstr
	define	_tcstod			wcstod
	define	_tcstok			wcstok
	define	_tcstol			wcstol
	define	_tcstoul		wcstoul
	define	_tcsupr			_wcsupr
	define	_tcsxfrm		wcsxfrm
	define	_tctime			_wctime
	define	_TDIR			_WDIR
	define	_tdirent		_wdirent
	define	_tfdopen		_wfdopen
	define	_tfinddata_t	_wfinddata_t
	define	_tfinddatai64_t	_wfinddatai64_t
	define	_tfindfirst		_wfindfirst
	define	_tfindfirsti64	_wfindfirsti64
	define	_tfindnext		_wfindnext
	define	_tfindnexti64	_wfindnexti64
	define	_tfopen			_wfopen
	define	_tfreopen		_wfreopen
	define	_tfsopen		_wfsopen
	define	_tfullpath		_wfullpath
	define	_tgetcwd		_wgetcwd
	define	_tgetdcwd		_wgetdcwd
	define	_tgetenv		_wgetenv
	define	_tmakepath		_wmakepath
	define	_tmkdir			_wmkdir
	define	_tmktemp		_wmktemp
	define	_topen			_wopen
	define	_topendir		_wopendir
	define	_totlower		towlower
	define	_totupper		towupper
	define	_tprintf		wprintf
	define	_tputenv		_wputenv
	define	_treaddir		_wreaddir
	define	_tremove		_wremove
	define	_trename		_wrename
	define	_trewinddir		_wrewinddir
	define	_trmdir			_wrmdir
	define	_tscanf			wscanf
	define	_tsearchenv		_wsearchenv
	define	_tseekdir		_wseekdir
	define	_tsetlocale		_wsetlocale
	define	_tsopen			_wsopen
	define	_tsplitpath		_wsplitpath
	define	_tstat			_wstat
	define	_tstat64		_wstat64
	define	_tstati64		_wstati64
	define	_tstrdate		_wstrdate
	define	_tstrtime		_wstrtime
	define	_tsystem		_wsystem
	define	_ttelldir		_wtelldir
	define	_ttoi			_wtoi
	define	_ttoi64			_wtoi64
	define	_ttol			_wtol
	define	_tunlink		_wunlink
	define	_tutime			_wutime
	define	_ui64tot		_ui64tow
	define	_ultot			_ultow
	define	_ungettc		ungetwc
	define	_vftprintf		vfwprintf
	define	_vsctprintf		_vscwprintf
	define	_vsntprintf		_vsnwprintf
	define	_vstprintf		vswprintf
	define	_vtprintf		vwprintf
	rept 0 \{
} match , {
	display '(ansi)'
	define	dz db
	define	_fgettc			fgetc
	define	_fgettchar		_fgetchar
	define	_fgetts			fgets
	define	_fputtc			fputc
	define	_fputtchar		_fputchar
	define	_fputts			fputs
	define	_ftprintf		fprintf
	define	_ftscanf		fscanf
	define	_gettc			getc
	define	_getts			gets
	define	_i64tot			_i64toa
	define	_istalnum		isalnum
	define	_istalpha		isalpha
	define	_istascii		__isascii
	define	_istcntrl		iscntrl
	define	_istdigit		isdigit
	define	_istgraph		isgraph
	define	_istlower		islower
	define	_istprint		isprint
	define	_istpunct		ispunct
	define	_istspace		isspace
	define	_istupper		isupper
	define	_istxdigit		isxdigit
	define	_itot			_itoa
	define	_ltot			_ltoa
	define	_puttc			putc
	define	_puttchar		putchar
	define	_putts			puts
	define	_sntprintf		_snprintf
	define	_stprintf		sprintf
	define	_stscanf		sscanf
	define	_taccess		_access
	define	_tasctime		asctime
	define	_tchdir			_chdir
	define	_tchmod			_chmod
	define	_tclosedir		closedir
	define	_tcreat			_creat
	define	_tcscat			strcat
	define	_tcschr			strchr
	define	_tcscmp			strcmp
	define	_tcscoll		strcoll
	define	_tcscpy			strcpy
	define	_tcscspn		strcspn
	define	_tcsdec			_strdec
	define	_tcsdup			_strdup
	define	_tcsftime		strftime
	define	_tcsicmp		_stricmp
	define	_tcsicoll		_stricoll
	define	_tcsinc			_strinc
	define	_tcslen			strlen
	define	_tcslwr			_strlwr
	define	_tcsnbcnt		_strncnt
	define	_tcsncat		strncat
	define	_tcsnccnt		_strncnt
	define	_tcsnccoll		_strncoll
	define	_tcsncicoll		_strnicoll
	define	_tcsncmp		strncmp
	define	_tcsncoll		_strncoll
	define	_tcsncpy		strncpy
	define	_tcsnextc		_strnextc
	define	_tcsnicmp		_strnicmp
	define	_tcsnicoll		_strnicoll
	define	_tcsninc		_strninc
	define	_tcsnset		_strnset
	define	_tcspbrk		strpbrk
	define	_tcsrchr		strrchr
	define	_tcsrev			_strrev
	define	_tcsset			_strset
	define	_tcsspn			strspn
	define	_tcsspnp		_strspnp
	define	_tcsstr			strstr
	define	_tcstod			strtod
	define	_tcstok			strtok
	define	_tcstol			strtol
	define	_tcstoul		strtoul
	define	_tcsupr			_strupr
	define	_tcsxfrm		strxfrm
	define	_tctime			ctime
	define	_TDIR			DIR
	define	_tdirent		dirent
	define	_tfdopen		_fdopen
	define	_tfinddata_t	_finddata_t
	define	_tfinddatai64_t	_finddatai64_t
	define	_tfindfirst		_findfirst
	define	_tfindfirsti64	_findfirsti64
	define	_tfindnext		_findnext
	define	_tfindnexti64	_findnexti64
	define	_tfopen			fopen
	define	_tfreopen		freopen
	define	_tfsopen		_fsopen
	define	_tfullpath		_fullpath
	define	_tgetcwd		_getcwd
	define	_tgetdcwd		_getdcwd
	define	_tgetenv		getenv
	define	_tmakepath		_makepath
	define	_tmkdir			_mkdir
	define	_tmktemp		_mktemp
	define	_topen			_open
	define	_topendir		opendir
	define	_totlower		tolower
	define	_totupper		toupper
	define	_tprintf		printf
	define	_tputenv		_putenv
	define	_treaddir		readdir
	define	_tremove		remove
	define	_trename		rename
	define	_trewinddir		rewinddir
	define	_trmdir			_rmdir
	define	_tscanf			scanf
	define	_tsearchenv		_searchenv
	define	_tseekdir		seekdir
	define	_tsetlocale		setlocale
	define	_tsopen			_sopen
	define	_tsplitpath		_splitpath
	define	_tstat			_stat
	define	_tstat64		_stat64
	define	_tstati64		_stati64
	define	_tstrdate		_strdate
	define	_tstrtime		_strtime
	define	_tsystem		system
	define	_ttelldir		telldir
	define	_ttoi			atoi
	define	_ttoi64			_atoi64
	define	_ttol			atol
	define	_tunlink		_unlink
	define	_tutime			_utime
	define	_ui64tot		_ui64toa
	define	_ultot			_ultoa
	define	_ungettc		ungetc
	define	_vftprintf		vfprintf
	define	_vsctprintf		_vscprintf
	define	_vsntprintf		_vsnprintf
	define	_vstprintf		vsprintf
	define	_vtprintf		vprintf
}

macro .import {
	library \
		kernel32,'KERNEL32.DLL',\
		user32,'USER32.DLL',\
		gdi32,'GDI32.DLL',\
		advapi32,'ADVAPI32.DLL',\
		comctl32,'COMCTL32.DLL',\
		comdlg32,'COMDLG32.DLL',\
		shell32,'SHELL32.DLL',\
		wsock32,'WSOCK32.DLL',\
		msvcrt40,'MSVCRT.DLL'
		
	import_kernel32
	import_user32
	import_gdi32
	import_advapi32
	import_comctl32
	import_comdlg32
	import_shell32
	import_wsock32
	import_msvcrt40
	
	all_api
}

macro .end value {
	if ~ value eq
		match =true, win64 \{
			label entry at value
			rept 0 \{
		\} match , \{
			entry value
		\}
	end if
	
	section '.idata' import data readable writeable
		.import
}
